<template>
  <div class="w-full h-fit min-w-[320px] max-w-[752px] min-h-[370px] max-h-[520px] flex flex-col rounded-[8px] border border-borderColor border-opacity-100 bg-surfaceBright">
    <div class="flex flex-col px-6 border-b border-borderColor border-opacity-100">
      <div class="w-full flex flex-col md:!flex-row md:!justify-between items-center gap-3 py-4">
        <div class="w-full flex flex-col">
          <svn-pro-title h6 medium>
            {{ chartTitle }}
          </svn-pro-title>
  
          <svn-pro-text subtitle-medium regular color="onSurfaceVariant">
            {{ chartDescription }}
          </svn-pro-text>
        </div>
  
        <div v-if="withCategory" class="w-full">
          <svn-pro-select
            v-model="category"
            :items="categories"
            :label="categoryLabel"
            :item-value="itemValue"
            :item-title="itemTitle"
            class="w-full md:!w-[372px]"
            @update:model-value="updateSelectedCategory"
          />
        </div>
      </div>

      <svn-pro-tabs
        v-if="withTabs"
        v-model="tabModel"
        color="primary"
        :items="tabItems"
        :grow="growTabs"
        :show-arrows="showArrows"
        :align-tabs="alignTabs"
      />
    </div>

    <div class="w-full h-[500px] flex flex-col px-6 py-4">
      <v-window v-if="withTabs" v-model="tabModel">
        <v-window-item
          v-for="tabItem in tabItems"
          :value="tabItem?.value"
        >
          <Bar
            v-if="tabItem?.chartType === chartTypes.bar"
            :data="tabItem?.chartData"
            :options="tabItem?.computedChartOptions"
            style="width: 100%; height: 100%;"
          />

          <Doughnut
            v-if="tabItem?.chartType === chartTypes.doughnut"
            :data="tabItem?.chartData"
            :options="tabItem?.computedChartOptions"
            :plugins="tabItem?.[chartPlugins]"
            style="width: 100%; height: 100%;"
          />

          <Line
            v-if="tabItem?.chartType === chartTypes.line"
            :data="tabItem?.chartData"
            :options="tabItem?.computedChartOptions"
            :plugins="tabItem?.[chartPlugins]"
            style="width: 100%; height: 100%;"
          />
        </v-window-item>
      </v-window>

      <template v-else>
        <Bar
          v-if="chartType === chartTypes.bar"
          :data="chartData"
          :options="computedChartOptions"
          style="width: 100%; height: 100%;"
        />
  
        <Doughnut
          v-if="chartType === chartTypes.doughnut"
          :data="chartData"
          :options="computedChartOptions"
          :plugins="[chartPlugins]"
          style="width: 100%; height: 100%;"
        />
  
        <Line
          v-if="chartType === chartTypes.line"
          :data="chartData"
          :options="computedChartOptions"
          :plugins="[chartPlugins]"
          style="width: 100%; height: 100%;"
        />
      </template>
    </div>
  </div>
</template>

<script setup>
import { ref, computed } from 'vue';
import { Doughnut, Bar, Line } from "vue-chartjs";
import SvnProText from '../styles/SvnProText.vue';
import { chartTypes, TabAlignTypes } from '../../constants/types';
import SvnProTitle from '../styles/SvnProTitle.vue';
import SvnProSelect from '../input/SvnProSelect.vue';
import SvnProTabs from '../tab/SvnProTabs.vue';
import {
  Chart as ChartJS,
  Title,
  Legend,
  Tooltip,
  ArcElement,
  PointElement,
  LineElement,
  BarElement,
  LinearScale,
  CategoryScale,
} from 'chart.js';

ChartJS.register(Title, Tooltip, Legend, ArcElement, BarElement, CategoryScale, LinearScale, PointElement, LineElement);

const props = defineProps({
  itemValue: { type: undefined, default: "id" },
  categories: { type: Array, default: () => [] },
  chartData: { type: Object, default: () => {} },
  withCategory: { type: Boolean, default: false },
  chartType: { type: String, default: chartTypes.doughnut },
  itemTitle: { type: undefined, default: "title" },
  chartPlugins: { type: Object, default: () => {} },
  chartTitle: { type: String, default: "Chart title" },
  categoryLabel: { type: String, default: "Category" },
  chartDescription: { type: String, default: "Chart description" },
  withTabs: {
    type: Boolean,
    default: false,
  },
  showArrows: {
    type: Boolean,
    default: false,
  },
  removeXMarkers: {
    type: Boolean,
    default: false,
  },
  removeYMarkers: {
    type: Boolean,
    default: false,
  },
  beginAtZero: {
    type: Boolean,
    default: false,
  },
  stepSize: {
    type: Number,
    default: undefined,
  },
  tabItems: {
    type: Array,
    default: () => [],
    validator: (value) =>  Array.isArray(value)
  },
  growTabs: {
    type: Boolean,
    default: false,
  },
  alignTabs: {
    type: String,
    default: TabAlignTypes.START,
    validator: (value) => Object.values(TabAlignTypes).find((element) => element === value)
  }
});

const emit = defineEmits([
  'update-selected-category',
])

const category = ref(null);
const tabModel = ref(null);
const computedChartOptions = computed(() => {
  let scales = {
    x: {
      grid: {
        display: !props.removeYMarkers,
      },
      stacked: true,
    },
    y: {
      grid: {
        display: !props.removeXMarkers,
      },
      ticks: {
        stepSize: props.stepSize,
      },
      beginAtZero: props.beginAtZero,
      stacked: true,
    },
  };

  return {
    responsive: true,
    maintainAspectRatio: false,
    scales: scales,
    plugins: {
      legend: {
        position: 'bottom',
        align: 'center',
      },
      tooltip: {
        padding: 6,
        titleFont: {
          family: 'Work Sans',
          weight: 500,
          size: 12
        },
        titleMarginBottom: 4,
        bodyFont: {
          family: 'Work Sans',
          size: 14
        },
        bodyAlign: 'left',
        boxWidth: 16,
        boxHeight: 8,
        boxPadding: 6,

      }
    },
  }
});

const updateSelectedCategory = (categoryId) => {
  emit('update-selected-category', categoryId);
}
</script>